<?php
// PukiWiki - Yet another WikiWikiWeb clone
// $Id: linkr.inc.php,v 1.02 2013/09/08 takayan Exp $
// Bug fix on define('PLUGIN_LINKR_SUFFIX')
// $Id: linkr.inc.php,v 1.01 2006/01/28 takayan Exp $
// source:
// $Id: imgr.inc.php,v 1.00 2005/08/18 takayan Exp $
// source of source:
// $Id: ref.inc.php,v 1.48 2005/01/28 11:58:56 henoheno Exp $
//
// plugin to make link(a) tag to a resource
//  with relative path specification
// Inline type only
//  Accept only relative path for file name
// Accept both letter(s) [w/ or w/o decoration using <span> tag]
//  and a image for link base (from v 1.01)

/////////////////////////////////////////////////
//  user-settings
/////////////////////////////////////////////////

// is_file check to execute or not - when not check, there may happened to make a deadlink
//  1 : do execute is_file check, 0 : not execute
define('PLUGIN_LINKR_FILE_CHECK', 1);

// return value for file not found case - set as you like
//  1 : return error message, 0 : return link title (without tags) or image (tag) only
define('PLUGIN_LINKR_NOFILE_RETURN', 0);

// identification for file not found - returning link title only case
//  set character as you like
define('PLUGIN_LINKR_TITLE_ONLY', "*");

// suffix check to execute or not - recommended to execute
//  1 : do execute is_file check, 0 : not execute
define('PLUGIN_LINKR_SUFFIX_CHECK', 1);

// link target suffixes allowed
define('PLUGIN_LINKR_SUFFIX', '/\.(shtml?|html?|cgi|php|rb|hdml|xml|rdf|rss|css|txt)$/i');
// for xrea : python not included
// define('PLUGIN_LINKR_SUFFIX', '/\.(?shtm?l|?xhtm|xcg|cgi|php|rb|hdml|xml|rdf|rss|css|txt)$/i');

/////////////////////////////////////////////////
//   please do not change
/////////////////////////////////////////////////

// Usage (a part of)
define('PLUGIN_LINKR_USAGE', "(link-to-file-name-in-relative-path[,new][,(title)]){image specification by &ref or &imgr plugin}");

// beginning of link_base (image) 
define('PLUGIN_LINKR_REGEX', '/^<img\s/');
  // includes <img> tag

// beginning of link_base (span) 
define('PLUGIN_LINKR_REGEX2', '/^<span\s/');
  // includes <span> tag

// error check of link_base ("nolink" not specified) 
define('PLUGIN_LINKR_NOREGEX', '/^<a\s/');
  // includes <img> tag

/////////////////////////////////////////////////
//   end of define section
/////////////////////////////////////////////////

function plugin_linkr_inline()
{
	// Not reached, because of "$aryargs[] = & $body" at plugin.php
	// if (! func_num_args())
	//	return '&amp;imgr(): Usage:' . PLUGIN_imgr_USAGE . ';';

	$params = plugin_linkr_body(func_get_args());

	if (isset($params['_error']) && $params['_error'] != '') {
		// Error
		return '&amp;linkr(): ' . $params['_error'] . ';';
	} else {
		return $params['_body'];
	}
}

function plugin_linkr_body($args)
{
	global $script, $vars;
    
    //  for test 
    // print_r($args);
    // echo '<br />';
    //  for test

	// 
	$params = array(
		'_blank' => FALSE, // target='_blank'
		'_args'  => array(),
		'_done'  => FALSE,
		'_error' => ''
	);

	// եΥե̾
	$name = '';

	// եޤǤΥѥ(ºݤ)ե̾
	$file = '';

	// : "ե̾"
	$name = array_shift($args);
    
    if (empty($name)) {
    
        $params['_error'] = htmlspecialchars('File not specified. ' . PLUGIN_LINKR_USAGE);
        return $params;
    
    }

	$matches = array();

    $nofile = 0;

	$temp = '';

	if (preg_match('#(^\.{1,2})(\/[0-9a-zA-Z_%=\'\(\)\;\:\$\-\+\?\!\*\#\.\&\@]{1,}){1,}#', $name, $matches)) {
		$temp = strtok($name,"?");
		$file = strtok($temp,"#");
        if (PLUGIN_LINKR_FILE_CHECK) {
		    $is_file = is_file($file);
		    if (! $is_file) {
                $nofile = 1;
                if (PLUGIN_LINKR_NOFILE_RETURN) {
			        $params['_error'] = htmlspecialchars('File not found: "' .
				        $file . '"' );
			        return $params;
                }
            }
		}
        if (PLUGIN_LINKR_SUFFIX_CHECK) {
		    $is_suffix = (preg_match(PLUGIN_LINKR_SUFFIX, $file));
		    if (! $is_suffix) {
			    $params['_error'] = htmlspecialchars('File specification ' . $name . ' is invalid for linkr plugin : allows only .(s)htm(l)/.cgi/.php/.rb/.hdml');
			    return $params;
            }
		}
	} else {
		$params['_error'] = htmlspecialchars('File specification ' . $name . ' is invalid for linkr plugin : allows only relative path for file name');
		return $params;
	}

	// Ĥΰν

    // 
    $_target = '';
    // 軰
    $_title = '';
    $_title2 = '';
    // Ͱ
    $linkbase = '';
    
	if (! empty($args))
		foreach ($args as $arg) 
			linkr_check_arg($arg, $params);
            
    // args ԤˤäƽѤ
    
    for ($i = 0; $i < 3; $i++ ) {
    
        if (empty($args[$i])) break;
        
        linkr_check_arg($args[$i], $params);
    
        // ѿλ : 'target="_blank"' å
        if ($params['_blank'] == TRUE && $_target == '') {
        
            $_target = ' target="_blank"';
            
        } else {

        // ͰɤȽꤷåȤѿѤ
			// ޤϥ顼å
			if (preg_match((PLUGIN_LINKR_NOREGEX), $args[$i], $matches)) {
				$params['_error'] = htmlspecialchars('ref or imgr plugin specification for image file is invalid for linkr plugin : should specify [,nolink] parameter');
				return $params;
			}

            if (preg_match((PLUGIN_LINKR_REGEX), $args[$i], $matches)) {

                $linkbase = strip_autolink($args[$i]);
                // already htmlspecialchars
                // return as-is for ref, imgr plugin execution result
                
			} else {
				if (preg_match((PLUGIN_LINKR_REGEX2), $args[$i], $matches)) {
                	$linkbase = strip_autolink($args[$i]);
                	// already htmlspecialchars
                	// return as-is for sizex plugin or other styles for letters execution result
                
            	} else {
            	
            	    $_title2 = htmlspecialchars($args[$i]);
            	    $_title = ' title="' . $_title2 . '"';
            	}

            }
                
        }
    
    }

    if ($_title != '' && $linkbase == '') {
        $linkbase = $_title2;
    }

    if ($_title == '' && $linkbase == '') {
		$params['_error'] = htmlspecialchars('Link specification is invalid for linkr plugin : should specify one or both of [title] and [image]');
		return $params;
    }
    
    if ($nofile) {
        $params['_body'] = PLUGIN_LINKR_TITLE_ONLY . $linkbase . PLUGIN_LINKR_TITLE_ONLY;
        return $params;
    }
    
    $_body1 = '';

	//  return link tag : $name and $linkbase puts at "as-is"
    $_body1 = htmlspecialchars($name);
    $params['_body'] = '<a href="'. $_body1. '"' . $_target . $_title . '>' . $linkbase . '</a>';

	return $params;

}

// ץϤ
function linkr_check_arg($val, & $params)
{
	if ($val == '') {
		$params['_done'] = TRUE;
		return;
	}

	if (! $params['_done']) {
		foreach (array_keys($params) as $key) {
			if (strpos($key, strtolower($val)) === 0) {
				$params[$key] = TRUE;
				return;
			}
		}
		$params['_done'] = TRUE;
	}

	$params['_args'][] = $val;
}

?>
